# ProtocolSchema

class `openff.evaluator.workflow.schemas.``ProtocolSchema`(unique_id=None, protocol_type=None, inputs=None)

  A json serializable representation of a workflow protocol.

  `__init__`(unique_id=None, protocol_type=None, inputs=None)

    Initialize self. See help(type(self)) for accurate signature.

  Methods

  `__init__`([unique_id, protocol_type, inputs]) | Initialize self.
  `from_json`(file_path) | Create this object from a JSON file.
  `get_attributes`([attribute_type]) | Returns all attributes of a specific attribute_type.
  `json`([file_path, format]) | Creates a JSON representation of this class.
  `parse_json`(string_contents[, encoding]) | Parses a typed json string into the corresponding class structure.
  `to_protocol`() | Creates a new protocol object from this schema.
  `validate`([attribute_type]) | Validate the values of the attributes.

  Attributes

  `id` | The unique id associated with the protocol.
  `inputs` | The inputs to the protocol.
  `type` | The type of protocol associated with this schema.

  `id`

    The unique id associated with the protocol. The default value of this attribute is not set and must be set by the user..

    Type

      str

  `type`

    The type of protocol associated with this schema. The default value of this attribute is not set and must be set by the user.. This attribute is read-only.

    Type

      str

  `inputs`

    The inputs to the protocol. The default value of this attribute is not set and must be set by the user.. This attribute is read-only.

    Type

      dict

  `to_protocol`()

    Creates a new protocol object from this schema.

    Returns

      The protocol created from this schema.

    Return type

      Protocol

  classmethod `from_json`(file_path)

    Create this object from a JSON file.

    Parameters

      file_path (str) – The path to load the JSON from.

    Returns

      The parsed class.

    Return type

      cls

  classmethod `get_attributes`(attribute_type=None)

    Returns all attributes of a specific attribute_type.

    Parameters

      attribute_type (type of Attribute, optional) – The type of attribute to search for.

    Returns

      The names of the attributes of the specified type.

    Return type

      list of str

  `json`(file_path=None, format=False)

    Creates a JSON representation of this class.

    Parameters

      - file_path (str, optional) – The (optional) file path to save the JSON file to.

      - format (bool) – Whether to format the JSON or not.

    Returns

      The JSON representation of this class.

    Return type

      str

  classmethod `parse_json`(string_contents, encoding='utf8')

    Parses a typed json string into the corresponding class structure.

    Parameters

      - string_contents (str or bytes) – The typed json string.

      - encoding (str) – The encoding of the string_contents.

    Returns

      The parsed class.

    Return type

      Any

  `validate`(attribute_type=None)

    Validate the values of the attributes. If attribute_type is set, only attributes of that type will be validated.

    Parameters

      attribute_type (type of Attribute, optional) – The type of attribute to validate.

    Raises

      ValueError or AssertionError –